<!DOCTYPE html>
<html lang="en">

<head>
	<title>67.S10</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Voucher</h2>
		<div class="jumbotron container">
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="voucher-code">Mã Voucher</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="discount">Phần trăm giảm giá</label>
				</div>
				<div class="col-sm-9">
					<input type="number" id="input-discount" name="discount" placeholder="Discount"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="note">Ghi chú</label>
				</div>
				<div class="col-sm-9">
					<input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="createDate">Ngày Tạo</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-createDate" name="createDate" placeholder="Create Date"
						class="form-control">
				</div>
			</div>
			<div class="row form-group">
				<div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				</div>
				<div class="col-sm-9">
					<input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
						class="form-control">
				</div>
			</div>
			<div class="row pull-right">
				<div>
					<button id="save_data" class="btn btn-info">Save Data</button>
				</div>
				<div class="ml-2">
					<button id="create_data" class="btn btn-success">Create Data</button>
				</div>
				<div class="ml-2">
					<button id="delete_data" class="btn btn-danger">Delete Data</button>
				</div>
			</div>
		</div>
		<table class="table table-bordered table-striped table-hover" id="user-table">
			<thead>
				<tr>
					<th>STT</th>
					<th>Mã giảm giá</th>
					<th>Phần trăm giảm giá</th>
					<th>Ghi Chú</th>
					<th>Ngày tạo</th>
					<th>Ngày cập nhật</th>
				</tr>
		</table>
	</div>
	<script>



		$(document).ready(function () {


			var table = $("#user-table").DataTable({
				"columns": [
					{ "data": "id" },
					{ "data": "maVoucher" },
					{ "data": "phanTramGiamGia" },
					{ "data": "ghiChu" },
					{ "data": "ngayTao" },
					{ "data": "ngayCapNhat" },
				]
			})

			var gID = "";	

			onPageLoading();

			$("#save_data").on('click', function () {
				onBtnSaveDataClick();
			})

			$("#create_data").on('click', function () {
				onBtnCreateClick();
			})

			$("#delete_data").on('click', function() {
				onBtnDeleteClick();
			})

			function onPageLoading() {
				getAllVouchers();
			}

			function onBtnSaveDataClick() {

				if(gID == "") {
					alert("bạn chưa chọn voucher");
				}
				else{
					//chuẩn bị, thu thập dữ liệu
					var vVoucherObj = {
						maVoucher: "",
						phanTramGiamGia: "",
						ghiChu: "",
						ngayTao: "",
						ngayCapNhat: "",
					}

					var dataVouchers = dataColection(vVoucherObj);
					//kiểm tra dữ liệu

					//goi api
					updateTableById(dataVouchers);
					//xử lý hiển thị
					getAllVouchers();
				}
				
			}

			function onBtnCreateClick(){
				//chuẩn bị, thu thập dữ liệu
				var vVoucherObj = {
					maVoucher: "",
					phanTramGiamGia: "",
					ghiChu: "",
					ngayTao: "",
					ngayCapNhat: "",
				}
				var dataVouchers = dataColection(vVoucherObj);
				//create voucher mới
				createVoucher(dataVouchers);
				//hàm sử lý hiển thị
				getAllVouchers();
			}

			function onBtnDeleteClick() {
				if(gID == "") {
					alert("Bạn có chắc chắn muốn xóa hết voucher")
					deleteAllVoucher();
					onPageLoading();
				}else{
					deleteVoucherById();
					getAllVouchers();
				}
			}

			//call api get vouchers
			function getAllVouchers() {
				$.ajax({
				url: "http://localhost:8080/vouchers",
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log(res);
					table.clear();
					table.rows.add(res);
					table.draw();
					onRowTableClick(table);
				},
				error: function (err) {
					console.log(err.response);
				}
			});
			}
			

			//click row table get data row by id
			function onRowTableClick(paramTable) {
				paramTable.on('click', 'tr', function () {
					var rowData = table.row(this).data();
					var id = rowData.id;
					gID = id;
					console.log(gID);
					$.ajax({
						url: "http://localhost:8080/vouchers/" + id,
						type: "GET",
						success: function (res) {
							console.log(res);
							loadDataToForm(res);
						},
						error: function (err) {
							console.log(err.status)
						}
					})
				})
			}

			//load data to form
			function loadDataToForm(paramResId) {
				$("#input-voucher-code").val(paramResId.maVoucher);
				$("#input-discount").val(paramResId.phanTramGiamGia);
				$("#input-note").val(paramResId.ghiChu);
				$("#input-createDate").val(paramResId.ngayTao);
				$("#input-updateDate").val(paramResId.ngayCapNhat);
			}

			//update data table by id
			function updateTableById(paramVoucher) {
					$.ajax({
						url: "http://localhost:8080/vouchers/" + gID,
						type: 'PUT',
						data: JSON.stringify(paramVoucher),
						contentType: 'application/json',
						success: function (res) {
							console.log(res);
						},
						error: function (err) {
							console.log(err.status)
						}
					})
			}

			// hàm thu thập dữ liệu trên form
			function dataColection(paramVoucher) {
				paramVoucher.maVoucher = $("#input-voucher-code").val();
				paramVoucher.phanTramGiamGia = $("#input-discount").val();
				paramVoucher.ghiChu = $("#input-note").val();
				paramVoucher.ngayTao = $("#input-createDate").val();
				paramVoucher.ngayCapNhat = $("#input-updateDate").val();

				return paramVoucher;
			}

			//call api create voucher
			function createVoucher(paramVoucher) {
				$.ajax({
					url: "http://localhost:8080/vouchers",
					type: "POST",
					data: JSON.stringify(paramVoucher),
    				contentType: "application/json",
					success: function(res) {
						console.log(res);
					},
					error: function(err) {
						console.log(err.status);
					}
				})
			}

			//api detele voucher
			function deleteVoucherById() {
				$.ajax({
					url: "http://localhost:8080/vouchers/" + gID,
					type: "DELETE",
					success: function(res) {
						console.log(res);
					},
					error: function (err) {
						console.log(err.status);
					}
				})
			}

			function deleteAllVoucher() {
				$.ajax({
					url: "http://localhost:8080/vouchers/",
					type: "DELETE",
					success: function(res) {
						console.log(res);
					},
					error: function (err) {
						console.log(err.status);
					}
				})
			}

		});

	</script>
</body>

</html>